Index: code/trunk/src/orxonox/controllers/ArtificialController.h
===================================================================
--- code/trunk/src/orxonox/controllers/ArtificialController.h	(revision 8952)
+++ code/trunk/src/orxonox/controllers/ArtificialController.h	(revision 9016)
@@ -31,15 +31,10 @@
 
 #include "OrxonoxPrereqs.h"
+#include "controllers/FormationController.h"
 
-#include <map>
-
-#include "util/Math.h"
-#include "Controller.h"
-#include "controllers/NewHumanController.h"
-#include "weaponsystem/WeaponSystem.h"
 
 namespace orxonox
 {
-    class _OrxonoxExport ArtificialController : public Controller
+    class _OrxonoxExport ArtificialController : public FormationController
     {
         public:
@@ -47,35 +42,7 @@
             virtual ~ArtificialController();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-
             void abandonTarget(Pawn* target);
 
-            inline void setTeam(int team)
-                { this->team_ = team; }
-            inline int getTeam() const
-                { return this->team_; }
-
-            inline void setFormationFlight(bool formation)
-                { this->formationFlight_ = formation; }
-            inline bool getFormationFlight() const
-                { return this->formationFlight_; }
-
-            inline void setFormationSize(int size)
-                { this->maxFormationSize_ = size; }
-            inline int getFormationSize() const
-                { return this->maxFormationSize_; }
-
-            inline void setPassive(bool passive)
-                { this->passive_ = passive; }
-            inline bool getPassive() const
-                { return this->passive_; }
-
             virtual void changedControllableEntity();
-
-            static void formationflight(const bool form);
-            static void masteraction(const int action);
-            static void followme();
-            static void passivebehaviour(const bool passive);
-            static void formationsize(const int size);
 
             virtual void doFire();
@@ -95,68 +62,12 @@
             void manageWaypoints();
 
+            
+
         protected:
-
-            int team_;
-            bool formationFlight_;
-            bool passive_;
-            unsigned int maxFormationSize_;
-            int freedomCount_;
-            enum State {SLAVE, MASTER, FREE};
-            State state_;
-            std::vector<ArtificialController*> slaves_;
-            ArtificialController *myMaster_;
-            enum SpecificMasterAction {NONE, HOLD, SPIN, TURN180, FOLLOW};
-            SpecificMasterAction specificMasterAction_;
-            int specificMasterActionHoldCount_;
-            float speedCounter_; //for speed adjustment when following
-
-            void moveToPosition(const Vector3& target);
-            void moveToTargetPosition();
-            void absoluteMoveToPosition(const Vector3& target);
-
-            virtual void positionReached() {}
-
-            void removeFromFormation();
-            void unregisterSlave();
-            void searchNewMaster();
-            void commandSlaves();
-            void setNewMasterWithinFormation();
-
-            void freeSlaves();
-            void forceFreeSlaves();
-            void loseMasterState();
-            void forceFreedom();
-            bool forcedFree();
-
-            void specificMasterActionHold();
-            void turn180Init();
-            void turn180();
-            void spinInit();
-            void spin();
-            void followInit(Pawn* pawn, const bool always = false, const int secondsToFollow = 100);
-            void followRandomHumanInit();
-            void follow();
-            void followForSlaves(const Vector3& target);
-
-            void setTargetPosition(const Vector3& target);
-            void searchRandomTargetPosition();
-
-            void setTarget(Pawn* target);
-            void searchNewTarget();
-            void forgetTarget();
+            
             void aimAtTarget();
 
             bool isCloseAtTarget(float distance) const;
             bool isLookingAtTarget(float angle) const;
-
-            void targetDied();
-
-            static bool sameTeam(ControllableEntity* entity1, ControllableEntity* entity2, Gametype* gametype); // hack
-            void boostControl(); //<! Sets and resets the boost parameter of the spaceship. Bots alternate between boosting and saving boost.
-
-            bool bHasTargetPosition_;
-            Vector3 targetPosition_;
-            WeakPtr<Pawn> target_;
-            bool bShooting_;
 
             float botlevel_; //<! Makes the level of a bot configurable.
@@ -165,6 +76,7 @@
             void setPreviousMode();
 
+
             //WEAPONSYSTEM DATA
-            std::map<std::string, int> weaponModes_; //<! Links each "weapon" to it's weaponmode- managed by setupWeapons()
+            std::map<std::string, int> weaponModes_; //<! Links each "weapon" to it's weaponmode - managed by setupWeapons()
             //std::vector<int> projectiles_; //<! Displays amount of projectiles of each weapon. - managed by setupWeapons()
             float timeout_; //<! Timeout for rocket usage. (If a rocket misses, a bot should stop using it.)
@@ -173,4 +85,5 @@
             int getFiremode(std::string name);
 
+
             //WAYPOINT DATA
             std::vector<WeakPtr<WorldEntity> > waypoints_;
@@ -178,4 +91,8 @@
             float squaredaccuracy_;
             WorldEntity* defaultWaypoint_;
+
+            void boostControl(); //<! Sets and resets the boost parameter of the spaceship. Bots alternate between boosting and saving boost.
+
+        private:
     };
 }
Index: code/trunk/src/orxonox/controllers/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/controllers/CMakeLists.txt	(revision 8952)
+++ code/trunk/src/orxonox/controllers/CMakeLists.txt	(revision 9016)
@@ -9,3 +9,4 @@
   WaypointPatrolController.cc
   DroneController.cc
+  FormationController.cc
 )
